

function A2
close all
dbstop if error

% Startwerte:
y0=[0.8;0];
t0=0;
T=1;

h = (1/2).^(1:10); % Schrittweiten

% Exact solution at T
y_von_T= y(T);



% Deklarationen:
err=zeros(3,10);

% Berechnung der Approximationen an y(T) mit den verschiednen
% Schrittweiten h(i), i=1,...,10: 
for i = 1:10 
        
    % Berechnung der Approx. mit den verschiedenen Verfahren:
    [~,y1] = Adams_Bashforth(t0,y0,h(i),@f,T);
    [~,y2] = Milne_Simpson(t0,y0,h(i),@f,@fy,T,1)
    [~,y3] = Milne_Simpson(t0,y0,h(i),@f,@fy,T,2);
    
    %hier werden die relativen Fehler berechnet:
    err(1,i)= norm(y1(:,end)-y_von_T);
    err(2,i)= norm(y2(:,end)-y_von_T);
    err(3,i)= norm(y3(:,end)-y_von_T);
    
end

%Plot der Norm des absoluten Fehlers gegen die Schrittweite h (in loglog):
figure;
loglog(h,err(1,:),h,err(2,:),h,err(3,:),h,h.^2,':',h,h.^3,':',h,h.^4,':');
legend('y_1 mit Adams Bashforth ','y_1 mit Milne Simpson und dem RKV mit A1,b1,c1 aus A 5.2b','y_1 mit Milne Simpson und dem Verfahren von Runge','h^2','h^3','h^4','location','NorthWest');
title('Fehlerplot: Adams-Bashforth bzw. Milne-Simpson (m=2)')
ylabel('Norm des absoluten Fehlers')
xlabel('Schrittweite h')

end

%% weitere Funktionen
% Diese sind so implementiert, dass Sie auch einen Vektor von Argumenten
% auswerten können. Das ist guter Matlabstil (hier aber nicht nötig).
%
% Ebenso haben f unf fy auch "t" als inputargument (obwohl nicht
% verwendet), damit es konsistent mit den Implementierungen der Verfahren
% ist.

function [Z]= y(t)
% Loesungsfunktion des AWPs

Z=[0.8*cos(sqrt(3)*t);-0.8*sqrt(3)*sin(sqrt(3)*t)];
end


function [Z] = f(t,Y)
% Funktion f des AWPs.

Z=[Y(2,:); -3*Y(1,:)];
end

function [Z] = fy(t,Y)
% Ableitung der Funktion f des AWPs nach der y-Komponente.

Z=kron(ones(1,length(Y(1,:))),[0 1; -3 0]);
end
